#include <stdio.h> 
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include "psleep.h"
#define N_INF 0
#define N_SUP 200
#define X_MAX 50
#define T_INF 5
#define T_SUP 10
#define TIMEOUT 40
int mystere; /* nombre mystre */
pthread_mutex_t mutex; /* mutex de protection */

void * prixJuste(void * arg) { /* routine de dpart du thread fuyeur */
    int t, x;
    while (1) {
    t = rand() % (T_SUP - T_INF + 1) + T_INF; /* temps d'attente */
    x = rand() % (X_MAX + 1); /* modification */
    sleep(t);
    pthread_mutex_lock(&mutex); /* protection modification */
    if (rand() % 2) { /* on ajoute ou on retire */
        printf("Le nombre mystre a t augment de %d !\n",x);
        mystere = ((mystere + x) > N_SUP) ? N_SUP : mystere + x;
    } else {
        printf("Le nombre mystre a t diminu de %d !\n",x);
        mystere = ((mystere - x) < N_INF) ? N_INF : mystere - x;
    }
    pthread_mutex_unlock(&mutex); /* fin de protection */
    }
}
void * timeout(void * arg) { /* routine de dpart du thread timeout */
    sleep(TIMEOUT);
    printf("Temps coul ! Perdu !\n");
    exit(1); /* exit() termine tout */
}
int main(int argc, char ** argv) {
    int mystere_local, proposition;
    pthread_t t1, t2;
    srand(getpid()); /* initialisation du gnrateur */
    pthread_mutex_init(&mutex, NULL); /* initialisation du mutex */
    mystere = rand() % (N_SUP - N_INF + 1) + N_INF; /* mystre */
    pthread_create(&t1, NULL, prixJuste, NULL); /* lancement des threads */
    pthread_create(&t2, NULL, timeout, NULL);
    while (1) { /* jeu classique du nombre mystre */
        printf("Proposition ?\n");
        scanf(" %d", &proposition);
        pthread_mutex_lock(&mutex); /* protection lecture */
        mystere_local = mystere;
        pthread_mutex_unlock(&mutex); /* fin de protection */
        if (proposition > mystere_local)
        printf("Trop grand !\n");
        else if (proposition < mystere_local)
        printf("Trop petit !\n");
        else
        break;
    }
    printf("Gagne !\n");
    return 0;
}

